Index: /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/PIContainerQuartz.cpp	(revision 4081)
@@ -14,4 +14,5 @@
 :PIContainerGen(par, nom, sx, sy, px, py)
 {
+	printf("PIContainerQuartz::PIContainerQuartz \n");
 }
 
Index: /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/PIWindowQuartz.cpp	(revision 4081)
@@ -17,5 +17,5 @@
 	
     SetRect(&wdgRect,px,py,px+sx,py+sy);
-	windowAttributes = kWindowStandardDocumentAttributes | kWindowCompositingAttribute ;
+	windowAttributes = kWindowStandardDocumentAttributes | kWindowCompositingAttribute | kWindowStandardHandlerAttribute | kWindowLiveResizeAttribute;
 	
 	err = CreateNewWindow (kDocumentWindowClass, windowAttributes, &wdgRect, &wRef);
@@ -30,4 +30,25 @@
 	HIViewGetBounds (wdgHIView, &bounds);
 
+//////
+/*
+ CGRect myBoundingBox;// 1
+	
+    myBoundingBox = CGRectMake (0, 0, myWidth, myHeight);// 2
+    myBitmapContext = MyCreateBitmapContext (400, 300);// 3
+    // ********** Your drawing code here ********** // 4
+    CGContextSetRGBFillColor (myBitmapContext, 1, 0, 0, 1);
+    CGContextFillRect (myBitmapContext, CGRectMake (0, 0, 200, 100 ));
+    CGContextSetRGBFillColor (myBitmapContext, 0, 0, 1, .5);
+    CGContextFillRect (myBitmapContext, CGRectMake (0, 0, 100, 200 ));
+    myImage = CGBitmapContextCreateImage (myBitmapContext);// 5
+    CGContextDrawImage(myContext, myBoundingBox, myImage);// 6
+    char *bitmapData = CGBitmapContextGetData(myBitmapContext); // 7
+    CGContextRelease (myBitmapContext);// 8
+    if (bitmapData) free(bitmapData); // 9
+    CGImageRelease(myImage);
+*/	
+///////
+
+	
 	printf("PIWindowQuartz::PIWindowQuartz Window View Bounds (%g %g) [%g %g] \n",
 											bounds.origin.x, bounds.origin.y,
@@ -40,4 +61,44 @@
 
 }
+/*
+ 
+CGContextRef PIWindowQuartz::MyCreateBitmapContext (int pixelsWide,
+									int pixelsHigh)
+{
+    CGContextRef    context = NULL;
+    CGColorSpaceRef colorSpace;
+    void *          bitmapData;
+    int             bitmapByteCount;
+    int             bitmapBytesPerRow;
+	
+    bitmapBytesPerRow   = (pixelsWide * 4);// 1
+    bitmapByteCount     = (bitmapBytesPerRow * pixelsHigh);
+	
+    colorSpace = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);// 2
+    bitmapData = calloc( bitmapByteCount );// 3
+    if (bitmapData == NULL)
+    {
+        fprintf (stderr, "Memory not allocated!");
+        return NULL;
+    }
+    context = CGBitmapContextCreate (bitmapData,// 4
+									 pixelsWide,
+									 pixelsHigh,
+									 8,      // bits per component
+									 bitmapBytesPerRow,
+									 colorSpace,
+									 kCGImageAlphaPremultipliedLast);
+    if (context== NULL)
+    {
+        free (bitmapData);// 5
+        fprintf (stderr, "Context not created!");
+        return NULL;
+    }
+    CGColorSpaceRelease( colorSpace );// 6
+	
+    return context;// 7
+}
+*/
+////
 
 void PIWindowQuartz::SetSize(int sx, int sy)
Index: /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/QuartzAppTest.cpp	(revision 4081)
@@ -145,10 +145,10 @@
 	
     /* Creation of Main Window */	
-    windowFirst = new PIWindow((PIMsgHandler *)mainApp, (const char *)"Window First",PIWK_normal, 700, 300, 50, 50);
+    windowFirst = new PIWindow((PIMsgHandler *)mainApp, (const char *)"Window First",PIWK_normal, 700, 700, 50, 50);
 	
     /* Creation of general graphical objects */
 	piLabel = new PILabel(windowFirst,(const char *)"Label", 80, 40, 150, 50);
 
-	piButton = new PIButton(windowFirst, "Hello", 777, 60, 20, 80, 80);
+	piButton = new PIButton(windowFirst, "Hello------2", 777, 60, 20, 80, 80);
 	
 	optMenu = new PIOptMenu(windowFirst, "Opt Menu", 100, 25, 150, 80);
@@ -159,8 +159,8 @@
 	optMenu->AppendPDMenu(popMenu);
 	
-	piLabel->SetLabel("Etiquette");
+	piLabel->SetLabel("Etiquette-------2");
 	
 	/* Creation of graphic Context */
-	twdg = new TstBWdg(windowFirst, "Test BaseQuartz", 400, 250, 300, 50);
+	twdg = new TstBWdg(windowFirst, "Test BaseQuartz", 500, 500, 200, 200);
 	windowFirst->Show();
 	
@@ -186,5 +186,5 @@
 void TstBWdg::Draw(PIGraphic* g, int x0, int y0, int dx, int dy)
 {
-	std::cout << "TstBWdg::Draw ";
+	std::cout << "TstBWdg::Draw +++++++++";
 
 	/*
@@ -205,4 +205,11 @@
 	g->DrawFBox(px, py, len, hei);
 	
+	PIGrCoord px2(0);
+	PIGrCoord py2(0);
+	PIGrCoord len2(500);
+	PIGrCoord hei2(500);
+	g->SelForeground(PI_Red);
+	g->DrawFBox(px2, py2, len2, hei2);
+	
 	px = 200 ; py = 50;
 	g->DrawString (px, py, "Graphic Text", 1);
Index: /trunk/SophyaPI/PI/Quartz/machdefs.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/machdefs.h	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/machdefs.h	(revision 4081)
@@ -362,8 +362,10 @@
 #define NO_VALUES_H
 /* BMX */
-#include "PI_Prefix.h"
+#ifdef __PIWQUARTZ__
+#include "PI_PrefixQuartz.h"
 /* #include "osx_values.h" */
 /* Faute de mieux pour le moment : */
 #define drand48() ((double)(random())/LONG_MAX)
+#endif
 #endif
 
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.cpp	(revision 4081)
@@ -15,12 +15,14 @@
 : PIBaseWdgGen(par,nom,sx,sy,px,py)
 {
-	HIRect localHIRect;
+
+ HIRect localHIRect;
 	HIViewRef rootView;
 	HIViewRef contentView;
 	OSStatus err;
+	fName = nom;
 	
 	rootView = ((PIWdg*)par)->GetHIViewRef();
 	err = HIViewGetBounds (rootView, &localHIRect);
-												
+
 	err = HIScrollViewCreate(kHIScrollViewOptionsVertScroll | kHIScrollViewOptionsHorizScroll, &wdgHIView);
 	err += HIViewSetVisible (wdgHIView, true);	
@@ -40,8 +42,8 @@
 	err += HIViewGetFrame (wdgHIView, &localHIRect);
 	
-	printf("PIBaseWdgQuartz::PIBaseWdgQuartz Set Frame (%g %g) [%g %g] err : %d \n",
+	printf("PIBaseWdgQuartz::PIBaseWdgQuartz Set Frame (%g %g) [%g %g] err : %d nom:%s\n",
 											localHIRect.origin.x, localHIRect.origin.y,
 											localHIRect.size.width, localHIRect.size.height,
-											err);
+											err,nom);
 
 	err = InstallEventHandler (GetControlEventTarget (wdgHIView),
@@ -53,5 +55,5 @@
 
 	HIViewRender(wdgHIView);
-
+	FinishCreate();
 	mWGrC = new PIGraphicWin(this);
 }
@@ -117,5 +119,6 @@
 void PIBaseWdgQuartz::Refresh()
 {
-	printf("PIBaseWdgQuartz::Refresh ");
+//	return;
+	printf("---->> PIBaseWdgQuartz::Refresh -%s- context:%lx\n",fName,mWGrC->GetCGContext());
 	EventRef	rEvent;
 	OSStatus err;
@@ -130,5 +133,4 @@
 	HIViewGetFrame(wdgHIView, &hiRect);
 
-	CGContextRestoreGState (mWGrC->GetCGContext());
 	printf(" cg : %lx ox : %g oy : %g width : %g height : %g \n",
 			mWGrC->GetCGContext(), hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
@@ -142,9 +144,15 @@
 void PIBaseWdgQuartz::eXposeProcess(CGContextRef cg, int x0, int y0, int dx, int dy)
 {
-	printf("PIBaseWdgQuartz::ExposeProcess \n");
-	CGContextSaveGState(cg);
-	mWGrC->SetCGContext(cg);
-	mWGrC->SetCTM(CGContextGetCTM(cg));
+	printf("PIBaseWdgQuartz::ExposeProcess -%s- to x:%d y:%d dx:%d dy:%d\n",fName,x0,y0,dx,dy);
+	if (mWGrC->GetCGContext() == NULL) {
+		mWGrC->SetCGContext(cg);
+		printf("PIBaseWdgQuartz::ExposeProcess CHANGE context to %lx\n",cg);
+		mWGrC->SetCTM(CGContextGetCTM(cg));
+	}
+	printf("PIBaseWdgQuartz::ExposeProcess set CTM to %lx\n",cg);
+	CGContextSaveGState(mWGrC->GetCGContext());
 	Draw(mWGrC, x0, y0, dx, dy);
+//	CGContextRestoreGState (cg);
+	CGContextRestoreGState (mWGrC->GetCGContext());
 
 	return;
@@ -160,13 +168,92 @@
 	
 	counterDraw++;
-	printf(" BaseWdgQuartzEventHandler (%d) : ", counterDraw);
 	PIGetEventName(event);
 
 	PIBaseWdgQuartz* wdg = (PIBaseWdgQuartz*) userData;
+	printf("\n BaseWdgQuartzEventHandler -%s- (%d) : ", wdg->fName,counterDraw);
+	printf("\n");
 
 	CGContextRef cg;
-		
+	WindowRef           window;
+    Rect                bounds;
+	if (!wdg)
+        return status;
+	
     status = GetEventParameter (event, kEventParamCGContextRef, typeCGContextRef, NULL, sizeof (CGContextRef), NULL, &cg);
 
+	switch(GetEventClass(event))
+    {
+/*        case kEventClassTablet:
+        case kEventClassMouse:
+            if (w->handleMouseEvent(event))
+                result = noErr;
+            break;
+        case kEventClassKeyboard:
+            if (w->handleKeyboardEvent(event))
+                result = noErr;
+            break;
+            
+*/        case kEventClassWindow: {
+			
+            switch (GetEventKind(event))
+			{
+				case kEventWindowBoundsChanging:
+					// left the code for live-resizing, but it is not used, because of window-refreshing issues...
+					GetEventParameter( event, kEventParamCurrentBounds, typeQDRectangle, NULL, sizeof(Rect), NULL, &bounds );
+					
+//					wdg->adaptResize(bounds.left, bounds.top, bounds.right - bounds.left, bounds.bottom - bounds.top);
+//					wdg->requestRedraw();
+					status = noErr;
+					break;
+					
+				case kEventWindowBoundsChanged:
+					InvalWindowRect(window, GetWindowPortBounds(window, &bounds));
+					GetWindowBounds(window, kWindowContentRgn, &bounds);
+//					wdg->adaptResize(bounds.left, bounds.top, bounds.right - bounds.left, bounds.bottom - bounds.top);
+					status = noErr;
+					break;
+                    
+				case kEventWindowClose:
+//					wdg->requestClose();
+					status = noErr;
+					break;
+					
+				default: 
+					break;
+			}
+		break;	
+		}
+		case kEventClassControl : {			
+			case kEventControlDraw: {
+				// wdg->SetQuartzCGContext(cg);
+				HIViewRef view = wdg->GetHIViewRef();
+				HIRect hiRect;
+				HIViewGetFrame(view, &hiRect);
+				// Pour le moment on rafraichit toute la vue
+				int ox = (int)(hiRect.origin.x);
+				int oy = (int)(hiRect.origin.x);
+				int dx = (int)(hiRect.size.width); 
+				int dy = (int)(hiRect.size.height);
+				printf("-->> PIbWdgquartz::BaseWdgQuartzEventHandler -%s- cg : %lx [%d %d] Frame [%d, %d] \n", wdg->fName,(unsigned long)cg, ox, oy, dx, dy);
+			
+				HIRect      bounds;
+				HIViewGetBounds ((HIViewRef) userData, &bounds);
+				printf("-->> PIbWdgquartz::BaseWdgQuartzEventHandler BOUNDS [%f %f] SIZE [%f, %f] \n",hiRect.origin.x,hiRect.origin.y,hiRect.size.width,hiRect.size.height);
+				//		err = HIViewSetFrame (wdgHIView, &localHIRect);
+				
+				wdg->eXposeProcess(cg, 0 , 0, dx, dy);
+			}
+			break;
+		}
+			break;	
+        default:
+            printf("unknown: %g\n",GetEventClass(event));
+            break;
+    }
+	
+	/////
+	
+	
+	
 	if (status != noErr)
 	{
@@ -175,5 +262,6 @@
 	else
 	{	
-		// wdg->SetQuartzCGContext(cg);
+/*
+ // wdg->SetQuartzCGContext(cg);
 		HIViewRef view = wdg->GetHIViewRef();
 		HIRect hiRect;
@@ -185,5 +273,12 @@
 		int dy = (int)(hiRect.size.height);
 		printf(" BaseWdgQuartzEventHandler cg : %lx [%d %d] Frame [%d, %d] \n", (unsigned long)cg, ox, oy, dx, dy);
+		
+		HIRect      bounds;
+		HIViewGetBounds ((HIViewRef) userData, &bounds);
+		printf(" BaseWdgQuartzEventHandler BOUNDS [%f %f] SIZE [%f, %f] \n",hiRect.origin.x,hiRect.origin.y,hiRect.size.width,hiRect.size.height);
+//		err = HIViewSetFrame (wdgHIView, &localHIRect);
+		
 		wdg->eXposeProcess(cg, 0 , 0, dx, dy);
+*/
 	}
 
Index: /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/pibwdgquartz.h	(revision 4081)
@@ -36,5 +36,5 @@
 */
 
-static const EventTypeSpec basewdgSpec[] = {{ kEventClassControl, kEventControlDraw}};
+static const EventTypeSpec basewdgSpec[] = {{ kEventClassControl, kEventControlDraw},{kEventWindowBoundsChanged,kEventWindowResizeCompleted}};
 
 
@@ -73,4 +73,5 @@
 //  Appel depuis le PIXtBaseWidget uniquement (ExposeEvt de Xt )
   virtual void       eXposeProcess(CGContextRef cg, int x0, int y0, int dx, int dy);
+	const char *fName;
  
 protected:
Index: /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/pigraphquartz.cpp	(revision 4081)
@@ -150,5 +150,7 @@
 	CGContextSetLineWidth (cgContext, 2);
 	CGContextStrokePath (cgContext);
-	CGContextClosePath (cgContext);
+
+	printf("PIGraphicQuartz::DrawLine Path\n");
+//	CGContextClosePath (cgContext);
 	CGContextFlush(cgContext);
 
@@ -240,5 +242,6 @@
 	CGContextAddLines(cgContext, points, n);
 	
-	CGContextClosePath(cgContext);
+	printf("PIGraphicQuartz::DrawPolygone ContextClosePath\n");
+//	CGContextClosePath(cgContext);
 	CGContextStrokePath(cgContext);
 	CGContextFlush(cgContext);
@@ -265,5 +268,6 @@
 	CGContextAddLines(cgContext, points, n);
 	
-	CGContextClosePath(cgContext);
+	printf("PIGraphicQuartz::DrawFPolygone ContextClosePath context:%lx /n",cgContext);
+//	CGContextClosePath(cgContext);
 	CGContextFillPath(cgContext);
 	CGContextFlush(cgContext);
@@ -290,5 +294,7 @@
 	CGContextAddArc (cgContext, xf, yf, radius, startAngle, endAngle, 0);
 	CGContextStrokePath(cgContext);
-	CGContextClosePath(cgContext);
+	
+	printf("PIGraphicQuartz::DrawArc ContextClosePath context:%lx \n",cgContext);
+//	CGContextClosePath(cgContext);
 	CGContextFlush(cgContext);
 
@@ -312,5 +318,6 @@
 	CGContextMoveToPoint (cgContext, xd, yd);
 	CGContextAddArc (cgContext, xf, yf, radius, startAngle, endAngle, 0);
-	CGContextClosePath(cgContext);
+	printf("PIGraphicQuartz::DrawFArc ContextClosePath\n");
+//	CGContextClosePath(cgContext);
 	CGContextFillPath(cgContext);
 	CGContextFlush(cgContext);
@@ -784,5 +791,6 @@
 	CGContextAddRect(cgContext, cgRect);
 
-	CGContextClosePath (cgContext);
+	printf("PIGraphicQuartz::SetClipRectangle ContextClosePath\n");
+//	CGContextClosePath (cgContext);
 	CGContextClip(cgContext);
 	CGContextFlush(cgContext);	
@@ -890,18 +898,23 @@
 void PIGraphicQuartz::SetCGContext(CGContextRef cg)
 {
-	if (cgContext != NULL)
-	{
-		printf("PIGraphicQuartz::SetCGContext Release CGContext %lx \n", (unsigned long)cgContext);
-		CGContextRelease (cgContext);
-		cgContext = NULL;
+	if (cgContext != NULL) return;
+
+	printf("PIGraphicQuartz::SetCGContext ---try to change %lx to %lx\n", (unsigned long)cgContext, (unsigned long)cg);
+	if (cgContext != cg) {
+		if (cgContext != NULL)
+			{
+				printf("PIGraphicQuartz::SetCGContext Release CGContext %lx \n", (unsigned long)cgContext);
+				CGContextRelease (cgContext);
+				cgContext = NULL;
+			}
+	
+		cgContext = CGContextRetain(cg);
+
 	}
-	
-	cgContext = CGContextRetain(cg);
-
 	HIRect hiRect;
 	HIViewGetFrame(hiViewRef, &hiRect);
 
-	printf("PIGraphicQuartz::SetCGContext Frame ox : %g oy : %g width : %g height : %g \n",
-			hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
+	printf("PIGraphicQuartz::SetCGContext Frame ox : %g oy : %g width : %g height : %g  cg : %lx \n",
+			hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height, (unsigned long)cg);
 	// SetGCRect(hiRect.origin.x, hiRect.origin.y, hiRect.size.width, hiRect.size.height);
 	return;
@@ -917,4 +930,5 @@
 	cgAffineTransform.tx = cat.tx;
 	cgAffineTransform.ty = cat.ty;
+	printf("PIGraphicQuartz::SetCTM a:%d b:%d c:%d d:%d tx:%d ty:%d\n",cat.a,cat.b,cat.c,cat.d,cat.tx,cat.ty);
 	return;
 }
@@ -924,5 +938,5 @@
 void PIGraphicQuartz::SetGCRect(float x0, float y0, float dx, float dy)
 {
-	printf("PIGraphicQuartz::SetGCRect %g %g %g %g \n", x0, y0, dx, dy);
+	printf("PIGraphicQuartz::SetGCRect %g %g %g %g CONTEXT:%lx \n", x0, y0, dx, dy,(unsigned) cgContext);
 //	CGAffineTransform cat;
 	CGContextScaleCTM (cgContext, 1., 1.);
Index: /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.cpp	(revision 4081)
@@ -355,2 +355,45 @@
 }
 
+
+PIScrollBarQuartz::PIScrollBarQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg, 
+									 int dir, int sx, int sy, int px, int py)
+: PIScrollBarGen(par, nom, msg, dir, sx, sy, px, py){
+	printf("PIScrollBarQuartz:PIScrollBarQuartz:   NOT IMPLEMENTED\n");
+}
+
+void PIScrollBarQuartz::GetMinMax(int& min, int& max){
+	printf("PIScrollBarQuartz::GetMinMax   NOT IMPLEMENTED\n");
+}
+
+
+int PIScrollBarQuartz::GetValue(){
+	printf("PIScrollBarQuartz::GetValue   NOT IMPLEMENTED\n");
+	return 0;
+}
+
+
+int PIScrollBarQuartz::GetSlSize(){
+	printf("PIScrollBarQuartz::GetSlSize   NOT IMPLEMENTED\n");
+	return 0;
+}
+
+
+void PIScrollBarQuartz::SetMinMax(int, int){
+	printf("PIScrollBarQuartz::SetMinMax   NOT IMPLEMENTED\n");
+}
+
+
+void PIScrollBarQuartz::SetSlSize(int){
+	printf("PIScrollBarQuartz::SetSlSize   NOT IMPLEMENTED\n");
+}
+
+
+void PIScrollBarQuartz::ActivateDrag(bool){
+	printf("PIScrollBarQuartz::ActivateDrag   NOT IMPLEMENTED\n");
+}
+
+
+void PIScrollBarQuartz::SetValue(int){
+	printf("PIScrollBarQuartz::SetValue   NOT IMPLEMENTED\n");
+}
+
Index: /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h
===================================================================
--- /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h	(revision 4080)
+++ /trunk/SophyaPI/PI/Quartz/pistdwdgquartz.h	(revision 4081)
@@ -120,4 +120,20 @@
 };
 
+class PIScrollBarQuartz : public PIScrollBarGen
+{
+public:
+	PIScrollBarQuartz(PIContainerQuartz *par, const char *nom, PIMessage msg = PIMsg_Click, 
+					  int dir=kSDirUpDown, int sx=10, int sy=100, int px=0, int py=0);
+	void SetMinMax(int, int);
+	void SetSlSize(int);
+	void SetValue(int);
+	void ActivateDrag(bool);
+    void GetMinMax(int&, int&);
+	void GetMinMax(int, int);
+	int GetValue();
+	int GetSlSize();
+
+};
+
 // INTERFACES
 
@@ -129,4 +145,5 @@
 typedef PITextQuartz PIText;
 typedef PIHITextViewQuartz PITextView;
+typedef PIScrollBarQuartz PIScrollBar;
 
 #endif
